local dewdrop = AceLibrary("Dewdrop-2.0")
local SML = AceLibrary("SharedMedia-1.0")
local L = AceLibrary("AceLocale-2.2"):new("Proximo")
local test = false

local defaults = {
		scale=1,
		x=0,
		y=0,
		framecolor = {r = 0, g = 0, b = .1, a = 1},
		fontsize=16,
		padding=5,
		barheight=22,
		barwidth=200,
		header=true,
		focus=true,
		texture="Minimalist",
		font="Friz Quadrata TT",
		announce="disabled",
		ma=UnitName("player"),
}

function Proximo:GetDefaultConfig()
	return defaults
end

function Proximo:SetupOptions()
	SML:Register("statusbar", "Minimalist", "Interface\\Addons\\Proximo\\Textures\\Minimalist")
	self.options = { 
	  type="group",
	  args = {
	  	framecolor = {
	  		type="color",
				name=L["FrameColor"],
		    desc=L["FrameColor"],
		    get=function()
		        return self.db.profile.framecolor.r, self.db.profile.framecolor.g, self.db.profile.framecolor.b, self.db.profile.framecolor.a
		    end,
		    set=function(r, g, b, a)
		        self.db.profile.framecolor.r, self.db.profile.framecolor.g, self.db.profile.framecolor.b, self.db.profile.framecolor.a = r, g, b, a
			 			self:UpdateFrame()
		    end,
		    hasAlpha=true,
		    order=1,
			},
	  	fontsize = {
				type="range",
				name=L["FontSize"],
				desc=L["FontSize"],
				get=function() return self.db.profile.fontsize end,
	  		set=function(v) self.db.profile.fontsize = v 
	  			self:UpdateFrame()
	  		end,
				min=8,
				max=36,
				step=1,
				order=2,
	  	},
	  	font = {
				type = 'text',
				name = L["Font"],
				desc = L["Font"],
				validate = SML:List('font'),
				get=function() return self.db.profile.font end,
	  		set=function(v) self.db.profile.font = v 
	  			self:UpdateFrame()
	  		end,
	  		order=3,
			},
	  	barwidth = {
				type="range",
				name=L["BarWidth"],
				desc=L["BarWidth"],
				get=function() return self.db.profile.barwidth end,
	  		set=function(v) self.db.profile.barwidth = v 
	  			self:UpdateFrame()
	  		end,
				min=100,
				max=500,
				step=5,
				order=4,
	  	},
	  	barheight = {
				type="range",
				name=L["BarHeight"],
				desc=L["BarHeight"],
				get=function() return self.db.profile.barheight end,
	  		set=function(v) self.db.profile.barheight = v 
	  			self:UpdateFrame()
	  		end,
				min=10,
				max=40,
				step=1,
				order=5,
	  	},
	  	texture = {
				type = 'text',
				name = L["BarTexture"],
				desc = L["BarTexture"],
				validate = SML:List('statusbar'),
				get=function() return self.db.profile.texture end,
	  		set=function(v) self.db.profile.texture = v 
	  			self:UpdateFrame()
	  		end,
	  		order=6,
			},
			padding = {
				type="range",
				name=L["Padding"],
				desc=L["Padding"],
				get=function() return self.db.profile.padding end,
	  		set=function(v) self.db.profile.padding = v 
	  			self:UpdateFrame()
	  		end,
				min=1,
				max=30,
				step=1,
				order=7,
	  	},
			scale = {
				type="range",
				name=L["Scale"],
				desc=L["Scale"],
				get=function() return self.db.profile.scale end,
	  		set=function(v) self.db.profile.scale = v 
	  			self:UpdateFrame()
	  		end,
				min=0.1,
				max=3,
				step=0.1,
				order=8,
	  	},
	  	announce = {
	  		type = "text",
				name = L["Announce"],
		    desc = L["Announce"],
		    get = function() return self.db.profile.announce end,
		    set = function(v) self.db.profile.announce = v end,
		    validate = {
		    	chat = CHAT_LABEL,
			    raid = CHAT_MSG_RAID_WARNING,
					sct = "SCT",
					msbt = "MSBT",
					disabled = "Disabled",
				},
				order = 9,
			},
			ma = {
				type = 'text',
				name = L["MainAssist"],
				desc = L["MainAssist"],
				usage = "<name>",
				get=function() return self.db.profile.ma end,
	  		set=function(v) self.db.profile.ma = v 
	  			self:SetMainAssist(v)
	  			self:SendCommMessage("PARTY", v)
	  			self:Print(L["MainAssist"]..": "..v)
	  		end,
	  		order=10,
			},
			focus = {
				type='toggle',
				name=L["Focus"],
				desc=L["Focus"],
				get=function() return self.db.profile.focus end,
				set=function(v) self.db.profile.focus = v 
	  			self:UpdateFrame()
	  		end,
				order=11,
			},
			header = {
				type='toggle',
				name=L["Header"],
				desc=L["Header"],
				get=function() return self.db.profile.header end,
				set=function(v) self.db.profile.header = v 
	  			self:UpdateFrame()
	  		end,
				order=12,
			},
			test = {
				type='toggle',
				name=L["Test"],
				desc=L["TestDesc"],
				get=function() return test end,
				set=function(v)
					test = v
					if v then 
						if self.frame==nil then
							self:MakeFrame()
						end
						self.frame:Show()
						self:Test()
					else 
						self:ResetList()
						self.frame:Hide()
					end 
				end,
				order=13,
			},
		}
	}
end

local function DewDropOptions()
  dewdrop:AddLine('text', 'Proximo Options','isTitle', true)
	dewdrop:InjectAceOptionsTable(Proximo, Proximo.options)
	dewdrop:FeedAceOptionsTable(Proximo.options)
end

function Proximo:DewDropMenu() 
	dewdrop:Open(Proximo.frame, 'children', DewDropOptions, 'cursorX', true, 'cursorY', true)
end